/* version control information */
#include "global.h"
#include "config.h"

char version[] = "NET/Mac 2.3.28";

/*
 * What this application is intended for:
 * ======================================
 * NET/Mac is an application, that has been created for ham-radio operators.
 * It can be used to hook up a Macintosh to the amateur-radio 'packet-radio'
 * wireless network. NET/Mac supports the TCP/IP protocol.
 * To use NET/Mac you need:
 * a) a ham-radio license
 * b) a transceiver connected to an antenna
 * c) a TNC that supports the KISS protocol
 * d) a Macintosh 512 or newer
 *
 * History
 * =======
 * The application NET/Mac, was ported (from Phil Karn's NET) to the Mac
 * by Dewayne WA8DZP.
 *
 * This release is based on Dewayne's NET/Mac 2.0 and contains all mods of
 * the newer NET/Mac 2.2. Both NET/Mac 2.0 and 2.2 were released by Dewayne
 * Hendricks and Doug Thom. Since some time I have been making mods (bug-
 * fixes and enhancements) to their NET/Mac, and have always sent them these
 * mods. Now that they are working on a new application, that will support
 * high speed networks and will also support AppleTalk over that network,
 * they have given me permission to distribute their NET/Mac with my mods
 * installed.
 * 
 * I hope you'll like the work I have done so far, and I will try to keep
 * 'upgrading' this application as much as possible. Don't bother Dewayne
 * or Doug in case you have problems or questions. Don't hesitate to call
 * me if any help is needed. I will try to be as helpful as I can. If you
 * want to become member of a 'NET/Mac distributionlist' (I myself prefer
 * internet for sending out newer versions...) then please leave me a note.
 * I may start sending out UpdateMaker documents that will allow you to
 * update NET/Mac to a newer version as soon as one has become available.
 * 
 * I'd like to thank Dewayne and Doug for the sources they gave me to work
 * on and Joe AF2J for already sending me a number of mods.
 * 
 *                                                Adam van Gaalen, PA2AGA.
 *                                                
 * 
 * My mail addresses are:  internet: pa2aga@igg.tno.nl
 *                       ham tcp/ip: pa2aga@pa2aga
 *                               or: pa2aga@pi8mac
 *                          ham BBS: pa2aga@pi8vnw.#zh2.nld.eu
 */


/* Modifications I made so far: + = installed some time ago
 *                              # = installed in version #
 *                              #R= installed in Release 2.3.#
 *
 *  File           Modification
 *  ----           ------------
58  arpcmd.c       Make syntax of error- and usage-messages more consistent
59                 Make syntax of error- and usage-messages more consistent
60                 Make syntax of error- and usage-messages more consistent
73                 Implement fixes for more 'Real-Time processing'
 +  arpdump.c      Support 'trace <interface> <bits> [filename]'
73  arp.c          Implement fixes for more 'Real-Time processing'
14R                Mods for new AppleTalk drivers,including FastPath/GatorBox support
50  ax25.c         Taken from V2.2
78                 Make sure pullup() gets called with the right parametertype
12R                Add the name of the interface to output of 'ax25 heard' command
14R                Check the result of the time() function
16R                Correct #include for unix.h
 +  ax25cmd.c      Tailor 'ax25 heard' output
 +                 Mods for UPLOAD command
42                 Do flowcontrol for incoming lines and those typed
31                 Force 'Connected' message to AX.25-window
46                 Do extended logging
48                 Incoming sessions draw more attention than incoming mail
58                 Make syntax of error- and usage-messages more consistent
59                 Make syntax of error- and usage-messages more consistent
60                 Save some space by moving some strings to 1 variable
67                 Cursors should appear only if typing in a window is allowed
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
72                 Change code so that it becomes more ANSI-like
73                 Update ax.25 window when state changes
73                 Implement fixes for more 'Real-Time processing'
78                 Update ax.25 window when state changes (1st mod was not enough)
10R                Force window-updates only if NET/Mac is not suspended
12R                Add the name of the interface to output of 'ax25 heard' command
15R                Return resultcode 0 if all was OK
16R                Correct #include for unix.h
19R                Mods for correctly displaying the systemprompt
 +  ax25dump.c     Support 'trace <interface> <bits> [filename]'
52                 Support 'traceonly [all|callsign]'
78                 Make sure pullup() gets called with the right parametertype
50  ax25subr.c     Taken from V2.2
78                 Make sure pullup() gets called with the right parametertype
 +  ax_mbx.c       Do not include '.bbs' in from-field of mbox-message
 +                 Fix bug in 'mbox' output
21                 Enhance test for control-z (for those that send cr + lf)
38     removed..   Make sure mailfiles are sent 'first in first out'
46                 Do extended logging
47                 Retransmit menu when an errormessage was sent out
58                 Make syntax of error- and usage-messages more consistent
59                 Make syntax of error- and usage-messages more consistent
60                 Make syntax of error- and usage-messages more consistent
73                 Notify users in case their LFADD is ON in their AX25 TNC
78                 Make sure pullup() gets called with the right parametertype
14R                Check the result of the time() function
18R                tmpfile() should  be tmpfile(0) or mbox mail will never be deleted
27R                Say goodbye when the user issued the B)ye command
58  cmdparse.c     Force Usage:-messages to correct window
22R                Force Usage:-messages to correct window
26R croft.c        Added some comments to the sourcecode
23R files.c        Define the 'universal' temp file and dynamic alias file
23R                Remove definitions for bm.rc, they're not needed
55  fingcli.c      Log outgoing finger-session
58                 Make syntax of error- and usage-messages more consistent
60                 Save some space by moving some strings to 1 variable
67                 Cursors should appear only if typing in a window is allowed
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
21R                Log reason for closing a session in case of networkproblems
24  fingserv.c     Callsign instead of ip-number in 'being fingered' message
48                 Incoming sessions draw more attention than incoming mail
55                 Log closing of finger-session
65                 Allow any user (username * and password * in ftpusers)
78                 Make sure pullup() gets called with the right parametertype
15R                Return resultcode 0 if all was OK
19R                Mods for correctly displaying the systemprompt
19R                Finger-files no longer need a .txt extension
78  ftp.c          Make sure pullup() gets called with the right parametertype
14R ftp.h          Implemented mods for password blanking
55  ftpcli.c       Log outgoing ftp-session
58                 Force Usage:-message to correct window
58                 Make syntax of error- and usage-messages more consistent
59                 Don't ring a bell when alerts is set to 0 bells
59                 Make syntax of error- and usage-messages more consistent
60                 Make syntax of error- and usage-messages more consistent
60                 Save some space by moving some strings to 1 variable
67                 Cursors should appear only if typing in a window is allowed
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
73                 Update ftp window when state changes
10R                Force window-updates only if NET/Mac is not suspended
14R                Implemented mods for password blanking
15R                Mods for Password-blanking
15R                Return resultcode 0 if all was OK
21R                Log reason for closing a session in case of networkproblems
78  ftpserv.c      Make sure pullup() gets called with the right parametertype
82                 Eventually supply 'ftpusers' with the right Icon
09R                Do the Icon-change based on the new 'netmacicons' command
14R                Check the result of the time() function
15R                Return resultcode 0 if all was OK
19R                FTP-users can no longer do a 'cd' to a file
23R                For incoming FTP-sessions send out FTEXT1 and FTEXT2
24R                Fix bug that crashed NET/Mac when receiving a 'cd ..'
25R                'cd ..' is the same as 'cd ::' now
28R                FTEXT1 and FTEXT2 will now be output according to the standards
 +  heard.h        Tailor 'ax25 heard' output
12R                Add the name of the interface to output of 'ax25 heard' command
 +  icmpcmd.c      Add callsign to 'ping' output
73                 Implement fixes for more 'Real-Time processing'
19R                Mods for correctly displaying the systemprompt
19R                Make syntax of error- and usage-messages more consistent
27R                Allow 'reset' to be the 2nd parameter of a 'ping' command
 +  icmpdump.c     Support 'trace <interface> <bits> [filename]'
60  iface.c        Save some space by moving some strings to 1 variable
72                 Change code so that it becomes more ANSI-like
 +  ipcmd.c        Tailor 'route' output
 +                 Add 'route expanded' command to see callsigns (not IP-#'s)
50                 Tailor 'ip heard' output. Stolen from V2.2
57                 Tailor 'route expanded' output
58                 Make syntax of error- and usage-messages more consistent
59                 Make syntax of error- and usage-messages more consistent
60                 Make syntax of error- and usage-messages more consistent
60                 Save some space by moving some strings to 1 variable
72                 Change code so that it becomes more ANSI-like
73                 Implement fixes for more 'Real-Time processing'
86                 No need for \r before printing \n
 +  ipdump.c       Support 'trace <interface> <bits> [filename]'
14R                Check the result of the time() function
63  ipheard.h      Reduce ip-heard space to 22 (was 100)
 +  iproute.c      Mods for reboot-problem
56                 Make sourcefile easier to read (0l -> 0L)
73  ip.c           Implement fixes for more 'Real-Time processing'
78                 Make sure pullup() gets called with the right parametertype
26R kip.h          Some opcodes were defined to be int, changed those to long
63  kiss.c         Allow like 'param ax0 KISS ON' on KISS-lines
64                 Allow controlcharacters (^a, ^b etc.) to be sent to a TNC
64                 Add stuff for Kantronics KPC-4
66                 Redo of some tricky programming
86                 Enhance ^<char> to control-character conversion
86                 No need for \r before printing \n
64  kpc.c          Add stuff for Kantronics KPC-4 (new sourcefile)
22R                Prepare source for compilation under Think C 4.0
78  lapb.c         Make sure pullup() gets called with the right parametertype
21R                Fix a minor AX.25 protocol error
22R                Fix a minor AX.25 protocol error
23R                Fix an error in these 'AX.25 protocol error' mods
22R lapb.h         Fix a minor AX.25 protocol error
 +  mac_about.c    Correct #include to make the filename case-insensitive
00R                Change versionnumber to 2.3.0
05R                Change copyright notice
27R                Change copyright notice
 +  mac_at.c       Don't '#include trace.h' twice
59                 Make syntax of error- and usage-messages more consistent
61                 Make syntax of error- and usage-messages more consistent
70                 Use new AppleTalk stuff
78                 Make sure pullup() gets called with the right parametertype
14R                New AppleTalk drivers,including FastPath/GatorBox support
14R                Fix bug that drove RIP crazy
18R                Remove 'applestat' command
23R                Terminate errormessage with a newline
 +  mac_at.h       Correct #include to make the filename case-insensitive
70                 Use new AppleTalk stuff
 +  mac_atdump.c   Correct #include to make the filename case-insensitive
 +                 Support 'trace <interface> <bits> [filename]'
56                 'at_dump()' is called with 2 parameters, but has only 1
14R                Implemented some fixes for the new AppleTalk drivers
73  mac_autoexec   Added code to update the autoexec.net file
09R                Do the Icon-change based on the new 'netmacicons' command
11R                Don't update the autoexec.net of a 512K Mac
23R                Do the Icon-change based on the 'netmacicons' command
23R                Do some more errorchecking
23R                Use the 'universal' temp file
21  mac_avail.c    Returns available disk-space in ftp 'dir' command
40                 Correct free-space info for large disks
41                 Enhance free-space info for large amounts of free space
21R                Fix for 512K Macs
22R                Fix for old 512K Macs
58  mac_bcncmd.c   Make syntax of error- and usage-messages more consistent
59                 Make syntax of error- and usage-messages more consistent
60                 Make syntax of error- and usage-messages more consistent
60                 Save some space by moving some strings to 1 variable
72                 Change code so that it becomes more ANSI-like
73                 Implement fixes for more 'Real-Time processing'
19R mac_binsubs.c  Fixes for not properly closing MacBinary-files after ftp
 +  mac_callbka.c  Tailor callbook layout (European people don't have zip's)
14R                Check the result of the time() function
15R                Updated by WA8DZP for new Buckmaster CD
16R                Support for encoded international database
17R                Fix programming error that caused 1-character suffix to fail
18R                Make sure licenses don't look like expired ones
18R                The log should read AX25, not TCP/IP
 +  mac_callbk.c   Tailor callbook layout (European people don't have zip's)
14R                Check the result of the time() function
15R                Updated by WA8DZP for new Buckmaster CD
16R                Support for encoded international database
17R                Fix programming error that caused 1-character suffix to fail
18R                Make sure licenses don't look like expired ones
18R                Log hostnames, not ip-numbers
23R                Add the missing linefeed behind the mail-address line
21  mac_files.c    Add info about free disk space to ftp 'dir' command
59                 Make syntax of error- and usage-messages more consistent
12R                Fix pathnames for old Mac512
12R                Show times in UTC when displaying a directory
19R                Finger-files no longer need a .txt extension
21R                More fixes for old 512K Macs
22R                More fixes for old 512K Macs
23R                More fixes for old 512K Macs
23R                Remove definitions for bm.rc, they're not needed
23R mac_files.h    Define the 'universal' temp file and dynamic alias file
23R                Remove definitions for bm.rc, they're not needed
77  mac_fopenw.h   Define width of scrollbars
04R mac_gestalt.c  Prepare sources for Gestalt()
05R                Assembler code for Gestalt()... Thanks Ivo!
09R                Gestalt will no longer be compiled in the 512K version
09R                Fixes for AddResMenu() bug in System 7.1
10R                Fixes for Mac LC II under System 7.0.1
 +  mac_help.c     Correct #includes to make the filename case-insensitive
09R                Fixes for AddResMenu() bug in System 7.1
21R                Force arrow-cursor when the HELP-window is active
22R                Don't force an arrow-cursor on a Mac512
63  mac_io.c       Allow like 'param sl0 ATDT<phonenumber' on slip-lines
74                 Although 'unsupported', support 38400 bps
86                 No need for \r before printing \n
18R                Flush the disk-cache before performing clr_tmpfiles()
18R                Keep files that could not be deleted in the RemoveIt list
28R                Prepare sources for support of 4-port serial card
58  mac_isescmd.c  Make syntax of error- and usage-messages more consistent
59                 Make syntax of error- and usage-messages more consistent
60                 Make syntax of error- and usage-messages more consistent
73                 Implement fixes for more 'Real-Time processing'
15R                Return resultcode 0 if all was OK
73  mac_ises.c     Implement fixes for more 'Real-Time processing'
08R mac_mactype.c  Move Mactypes to a different segment, so we can unload it
09R                Gestalt will no longer be used in the 512K version
10R                Fixes for Mac LC II under System 7.0.1 and more
11R                Don't compile this for an old Mac 512
 +  mac_misc.c     Mods for UPLOAD command
30                 Support remote-reboot
56                 New command: 'rip trace on' (by AF2J)
60                 Save some space by moving some strings to 1 variable
62                 Change name 'back_to_console' into 'lastActiveSession'
67                 Mods for 'SMTP trace' window
67                 Update 'lastActiveSession' when the user clicks a window
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
69                 Mods for split-windows for TELNET, AX.25 and NET/ROM
83                 Introduce 'User-defined' menu stuff
86                 Allow \<char> for control-characters in a menu-item
04R                Enable/disable Custom menu depending on frontwindow
06R                The 'Custom' menu no longer uses the clipboard
14R                Check the result of the time() function
18R                Leave drawing of the MenuBar to mac_toolsevents()
22R                Translate 2 backslashes in a menu-item into 1 slash
28R                Disable 'Custom' menu when showing a 'Finger' session
60  mac_path.c     Make syntax of error- and usage-messages more consistent
73                 Make errormessages more helpful
12R                Fix pathnames for old Mac512
15R                More fixes for 512K Macs
17R                Add conditional code for PA3ECP's Mac XL
18R                Flush the disk-cache before calling clr_tmpfiles()
20R                More fixes for 512K Macs
21R                More fixes for 512K Macs
22R                More fixes for 512K Macs
23R                More fixes for 512K Macs
23R                Define the 'universal' temp file and dynamic alias file
23R                Remove definitions for bm.rc, they're not needed
23R mac_perform_at Implement 'perform <command> <HH:MM>' command
25R                Chang the syntax to: 'perform <command> <HH:MM>|+<delay> o|p'
27R                Add command: 'perform clear', which clears the whole list
28R                Modify the 'usage' message so that 'perform clear' is included
28R                Display delay in minutes, not seconds
28R                Fix for permanent commands with a +<delay>
09R mac_realtime.c New... Draws and updates the statistics window
15R                Enlarge realtime window
21R                Fix for values bigger than maximum
56  mac_rip.c      New command: 'rip trace on' (by AF2J)
71                 Fix some dirty sourcelines in rip_recv()
72                 Make sure windows update properly even when not in front
73                 Enhance mods of modset 72
73                 Implement fixes for more 'Real-Time processing'
78                 Stop sending out faulty RIP-packets
78                 Solved a bug that made the Mac crash every now and then
79                 Another bug solved in the RIP-receive code
80                 Correct a typo, that destroyed RIP-interfaces
10R                Force window-updates only if NET/Mac is not suspended
23  mac_ripcmd.c   Tailor 'rip status' output
56                 New command: 'rip trace on' (by AF2J)
59                 Make syntax of error- and usage-messages more consistent
60                 Save some space by moving some strings to 1 variable
67                 Check RIP window when it is selected by a RIP TRACE command
67                 Allow the user to define location and size of RIP window
67                 Cursors should appear only if typing in a window is allowed
68                 Check for valid hostname in 'rip' commands
04R                Enable/disable Custom menu depending on frontwindow
15R                Return resultcode 0 if all was OK
45  mac_tools.c    If no window is a checked window, go to then console-window
53                 Fix bug in above mod, that seemed to crash on a Macintosh LC only
57                 Mod for the RIP Trace window.. check when clicked
60                 Save some space by moving some strings to 1 variable
67                 Mods for 'SMTP trace' window
67     removed..   Update 'lastActiveSession' when the user clicks a window
69                 Mods for split-windows for TELNET, AX.25 and NET/ROM
74                 Enable Paste-menu
77                 Make sure we look at the correct window
80                 Add a command-G option in the edit-menu
81                 Make sure SetPort points to the FrontWindow
82                 Fix SysEnvirons calls
83                 Introduce 'Settings' menu
04R                Enable/disable Custom menu depending on frontwindow
05R                Some more mods to make sure the window we look at is the active one
09R                Mods for the statistics window
10R                Force window-updates only if NET/Mac is not suspended
11R                When used on an old Mac512 assume non-adb keyboard
13R                Disable 'Help...' menu when HELP is not available
17R                Before going to the background try to switch to an arrowcursor
18R                mac_toolsevents() will redraw MenuBar if necessary
21R                Map option-command G and option-command V for non-ADB keyboards
28R                Disable 'Custom' menu when showing a 'Finger' session
42  mac_ttydriv.c  Do flowcontrol for incoming lines and those typed
56                 Don't allow typing into the RIP Trace Window
57                 Force ^R type-in to the right window (by AF2J)
67                 Mods for 'SMTP trace' window
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
15R                Mods for Password-blanking
50  mac_whois.c    Added. This file was taken from the V2.2 release
80                 Display a watch-cursor when going through host.net
82                 Slow down the rotating cursor
07R                Show my picture when people ask who I am
09R                Eventually supply 'hosts.net' with the right Icon
09R                Do the Icon-change based on the new 'netmacicons' command
11R                Never show my face on a 512K Mac
22R                A lot of people want to know about ON1XK, so...
24R                Call cursor routines in the right way
 +  main.c         Record StartUp time in LOG-file
 +                 Log callsign:socket, not ip-number:socket
 +                 Fix keyboard-locked bug
 +                 Support 'trace <interface> <bits> [filename]'
 +                 Fix doremote()
 +                 Allow list of autoexec.net-commands
22                 Support 'log <filename> [overwrite]'
25                 Write complete TRACE command to trace-file (for debugging)
26                 Put machineType in smtp's share and enjoy message
28                 Fix small problem in trace (NO trace but STILL a window)
34                 Add more machinetypes (LC and Classic)
37                 Add more machinetypes (IIfx and IIsi)
42                 Allow flowcontrol for incoming lines and those typed
46                 Do extended logging
46                 Check parameters of 'flow' command
47                 Enhance trace-mods; sometimes traceinfo goes to mailfile 
50                 Add 'whois <callsign | ip-number>' command (from V2.2)
50                 Add 'hostfile <filename>' command (from V2.2)
52                 Polish code for obtaining Macintosh type
52                 Support 'traceonly [all|callsign]'
53                 Show 'traceonly' values when starting to trace
58                 Check for valid hostname in 'remote' command
58                 Force Usage:-message to correct window
58                 Make syntax of error- and usage-messages more consistent
59                 Allow 'record|upload <filename> [<sessionnumber>] command
59                 Make syntax of error- and usage-messages more consistent
60                 Save some space by moving some strings to 1 variable
60                 Make syntax of error- and usage-messages more consistent
61                 Fix  for current session-number and <escape>-key
62                 Change name 'back_to_console' into 'lastActiveSession'
64                 Add stuff for Kantronics KPC-4
65                 Redo of the Mac-type recognition
65                 New 'prompt' command implemented
66                 Fix little bug in new 'prompt' command
66                 Add more machinetypes (Quadra's, PowerBook's, Classic II)
67                 Allow the user to define location and size of LOG window
67                 Allow the user to define location and size of CONSOLE window
67                 Cursors should appear only if typing in a window is allowed
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
68                 Check for valid hostname in 'rip' commands
69                 Fix SysEnvirons call
71                 Implement 'rtntoses [on|off]' command
72                 Change code so that it becomes more ANSI-like
72                 Make sure windows update properly even when not in front
73                 Slow down updating the tracewindow
73                 Implement fixes for more 'Real-Time processing'
74                 Enable Paste-menu
79                 Make sure routing table is properly preset to NULLROUTE's
79                 Implement console-commands 'date' and 'time'
80                 Show a WatchCursor when going through autoexec.net
80                 Add a command-G option in the edit-menu
81                 Auto-adjust cursortype when the mouse has been moved
82                 Balance the speed of the rotating cursor to the speed of the CPU
83                 Some more cursor mods
83                 Introduce 'Settings' menu
83                 Introduce 'User-defined' menu and 'addmenu' command
84                 Some more cursor mods
84                 Change 'User-defined' to 'Custom' menu
84                 Remove some obsolete sourcecode from PasteIfSomethingsThere()
84                 Improve copying of commands to clipboard
85                 Replace ' by " in menustrings
85                 Implement 'source' command (mods by AF2J)
86                 Put '#$debug on\n' in  char debugOn[]
86                 Check for invalid menu-string characters
00R                Make syntax of error- and usage-messages more consistent
01R                Mods for smtpndays
02R                Fixes for 'Auto Operator'
03R                Log 'Auto Operator' actions in the log-file, not the console
03R                InactiveTimer implemented for sessions, that seem obsolete
04R                Implement 'title' and change default console-title
04R                Enable/disable Custom menu depending on frontwindow
04R                Prepare sources for Gestalt()
05R                Prepare sources for Gestalt()
05R                Enable/disable Custom menu depending on frontwindow
06R                The 'Custom' menu no longer uses the clipboard
07R                Show inactiveTimer in 't s #' command-output
08R                Prepare NET/Mac for the newer Macintoshes
08R                Fix to make x and y parameters of Console command work
08R                Move Mactypes to a different segment, so we can unload it
09R                Mods for the statistics window
09R                Implementation of new 'netmacicons on|off' command
09R                Fixes for AddResMenu() bug in System 7.1
10R                Force window-updates only if NET/Mac is not suspended
10R                Support mail-delivery over AppleShare
11R                HELP not defined? Tell the user about the HMgr resource
11R                Enhance syntax-checking for 'appleshare' command
11R                Fix problem with flashing HELP-balloons
11R                Don't update the autoexec.net of a 512K Mac
11R                Tell the user we need at least System 4.1 when no SysEnvirons
11R                On an old Mac512 don't try to call SysEnvirons()
12R                Show times in UTC when displaying a directory
13R                Don't call UnloadSeg() on an old 512K Mac
13R                Tell a Mac512 user which resources can be deleted
13R                Check the result of the time() function
14R                Enhance the CheckClock() routine
14R                Implemented mods for Serial Line Framing Protocol
14R                Improve some dirty programming
14R                Show NET/Mac versionnumber in Consolewindow-title
14R                Mods for Password-blanking
15R                Mods for Password-blanking
15R                Return resultcode 0 if all was OK
15R                Implemented 'sesscreen [<width>]' command
16R                'sesscreen [<width>]' is now 'sesscreen [<width> [<length>]]'
16R                Enhance checking of 'trace <interface> <mode>' command
16R                Mods to support encoded international database
16R                Support 'inquire <callsign>' command from console
17R                Support 'callbookserver <hostname>' command
18R                Make the System 7.1-MyAddresMenu-message conditional
18R                Remove 'applestat' command
19R                Forget about CPU speed in the Macintosh-type printout
19R                The size of the trace-window can be defined in the trace-command
19R                Make syntax of error- and usage-messages more consistent
20R                Tell a Mac512 user which resources can be deleted
20R                Take care of the Bus Errors that happened in 2.3.19
21R                Support 'ctext1 [<text>]' and 'ctext2 [<text>]' commands
21R                When using a non-ADB keyboard command-Q will not Quit NET/Mac
22R                Hide the I-beam cursor until COPY from the menu is really there
23R                Enhance checking for obsolete open sessions
23R                Show '\\' as '/' in the Custom Menu Items
23R                Implement code for 'perform [<command> <HH:MM> [once|permanent]]'
23R                New command 'dontalias <user> [<user>] [<user>] ....'
23R                Support 'ftext1 [<text>]' and 'ftext2 [<text>]' commands
24R                Call cursor routines in the right way
25R                Show the time after processing the 'tzone' command
25R                Allow user to change the 'dontalias' definitions
26R                The command 'smtpndays <#days>' is now 'smtp ndays <#days>'
26R                Implemented new command 'softkiss' to enable SoftKiss fixes
28R                Never change cursors when running in suspended mode
28R                FTEXT1 and FTEXT2 will now be output according to the standards
28R                Prepare sources for support of 4-port serial card
78  mbuf.c         Make sure pullup() gets called with the right parametertype
16R                New version received from PE1CHL to fix DUP mbuf problem
16R mbuf.h         New version received from PE1CHL to fix DUP mbuf problem
09R MyAddResMenu.c Fixes for AddResMenu() bug in System 7.1
11R                Do NOT compile this if HELP is not defined in config.h
46  netrom.h       Do extended printing of 'netrom rout' command-output
 +  netuser.c      Add conversion-routine for ip-number to callsign
80                 Show a WatchCursor when going through hosts.net
82                 Slow down the rotating cursor
83                 Show a WatchCursor when going through hosts.net
19R                Ignore comment at the end of hosts.net lines
24R                Call cursor routines in the right way
 +  netuser.h      Define inet_n2h() and phsocket()
33  nr3.c          Changed some NET/ROM constants
46                 Do extended printing of 'netrom rout' command-output
59                 Make syntax of error- and usage-messages more consistent
78                 Make sure pullup() gets called with the right parametertype
73  nr4subr.c      Implement fixes for more 'Real-Time processing'
78                 Make sure pullup() gets called with the right parametertype
73  nr4user.c      Implement fixes for more 'Real-Time processing'
73  nr4.c          Implement fixes for more 'Real-Time processing'
 +  nr4.h          Fix 'bomb' bug in NET/ROM-sessions
 +  nrcmd.c        Fix 'bomb' bug in NET/ROM-sessions
 +                 NETOM is now NETROM in 'window'-menu
 +                 Mods for UPLOAD command
42                 Do flowcontrol for incoming lines and those typed
31                 Force 'Connected' message to NET/ROM-window
46                 Do extended printing of 'netrom route' command-output
46                 Do extended logging
48                 Incoming sessions draw more attention than incoming mail
58                 Make syntax of error- and usage-messages more consistent
59                 Make syntax of error- and usage-messages more consistent
60                 Save some space by moving some strings to 1 variable
60                 Make syntax of error- and usage-messages more consistent
64                 Don't allow NET/ROM on non-NET/ROM interfaces
67                 Cursors should appear only if typing in a window is allowed
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
69                 Seconds should be milliseconds in some command-responses
70                 Use strcpy() all over the place
72                 Change code so that it becomes more ANSI-like
73                 Implement fixes for more 'Real-Time processing'
04R                Enable/disable Custom menu depending on frontwindow
15R                Return resultcode 0 if all was OK
19R                Mods for correctly displaying the systemprompt
23R                'netrom nodefilter' command also shows nodefilter mode
78  nrs.c          Make sure pullup() gets called with the right parametertype
78  nrsubr.c       Make sure pullup() gets called with the right parametertype
73  rip.h          Implement fixes for more 'Real-Time processing'
 +  session.c      Mods for UPLOAD command
36                 Mods for RECORD command
58                 Try not to expand inactive sessions
59                 Make syntax of error- and usage-messages more consistent
59                 Allow 'record|upload <filename> <sessionnumber> command
59                 Fix 'close'- and 'session'-command for current session
60                 Save some space by moving some strings to 1 variable
62                 A <RETURN> switches back to the last session (by AF2J)
62                 Change name 'back_to_console' into 'lastActiveSession'
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
71                 Implement 'rtntoses [on|off]' command
77                 Redraw window after switching to another one
04R                Enable/disable Custom menu depending on frontwindow
14R                Implemented mods for password blanking
15R                Mods for Password-blanking
27R                Recording a session should result in a TEXT-file, single-spaced
28R                Disable 'Custom' menu when showing a 'Finger' session
68  session.h      Implement split-windows for TELNET, AX.25 and NET/ROM
14R                Implemented mods for password blanking
78  slip.c         Make sure pullup() gets called with the right parametertype
25R                Fix a problem, that was caused by SoftKiss 1.6
26R                Fixes for a problem, that was caused by SoftKiss pre1.8
30  smisc.c        Support remote-reboot
14R                Check the result of the time() function
15R                Return resultcode 0 if all was OK
 +  smtpcli.c      Fix SMTP-timer sometimes showing wrong timervalue
38     removed..   Make sure mailfiles are sent 'first in first out'
39                 Log ALL outgoing mail
49                 Also show hostname in some SMTP messages
58                 Make syntax of error- and usage-messages more consistent
59                 Make syntax of error- and usage-messages more consistent
60                 Make syntax of error- and usage-messages more consistent
67                 Mods for 'SMTP trace' window
67                 Allow the user to define location and size of SMTP window
67                 Cursors should appear only if typing in a window is allowed
72                 Make sure windows update properly even when not in front
73                 Implement fixes for more 'Real-Time processing'
78                 Make sure pullup() gets called with the right parametertype
01R                Mods for smtpndays
02R                Mods for smtpndays
04R                Enable/disable Custom menu depending on frontwindow
10R                Force window-updates only if NET/Mac is not suspended
12R                Fix pathnames for old Mac512
14R                Check the result of the time() function
15R                Return resultcode 0 if all was OK
18R                fflush() SMTPXXXXX tempfiles and disk-cache after fclose()
21R                If mail can't be delivered, report the name of the destination
23R                Make sure 'smtp timer 0' stops smtp timer until further notice
26R                Introduce 'smtp vm' command to cure the SMTP problem in IBM's VM
26R                The command 'smtpndays [<#days>]' is now 'smtp ndays [<#days>]'
26  smtpserv.c     Put machineType in smtp's share and enjoy message
38                 Make sure mailfiles are sent 'first in first out'
48                 Incoming sessions draw more attention than incoming mail
54                 Try to optimize outgoing mail as much as possible
56                 Fix typo, that accidently terminated an IF-statement
65                 Remove any existing controlcharacters in <user@.....>
66                 Increase size of ourname[] for longer Macintosh names
78                 Make sure pullup() gets called with the right parametertype
80                 Show a WatchCursor when mailing files
01R                Mods for smtpndays
02R                Allow only 1 incoming SMTP from a given host, kill the others
08R                Prepare for longer Macintosh names (like: PowerBook DUO 230)
09R                Eventually supply 'alias' with the right Icon
09R                Do the Icon-change based on the new 'netmacicons' command
10R                Support mail-delivery over AppleShare
12R                Fix pathnames for old Mac512
13R                Don't report failing AppleShare mail-delivery
14R                Check the result of the time() function
15R                Return resultcode 0 if all was OK
18R                fflush() SMTPXXXXX tempfiles and disk-cache after fclose()
19R                Mods for correctly displaying the systemprompt
22R                Undeliverable mail should be returned hop-to-hop
23R                New command 'dontalias <user> [<user>] [<user>] ....'
24R                Call cursor routines in the right way
25R                Don't dynamically alias 'mailer-daemon'
26R                Assign 0L instead of 0 to long int variable 'sequence'
27R                In case we cannot get sequence.seq... delay and try again
27R                Don't generate duplicate callsigns for hop-to-hop addressing
35  smtp.h         Prevent from crashing when long SMTP lines come in
38                 Fix for mailfiles that have 8 character long names
01R                Mods for smtpndays
13R                Forget about the stupid MS/DOS 8 character filenames
21R                If mail can't be delivered, report the name of the destination
27  tcp.h          Implement new 'max_retry_timer' (tcp mrtt [milliseconds])
03R                Mods for inactiveTimer
 +  tcpcmd.c       Show callsign:socket in 't s' command
20                 Show control-block numbers in 't s' command
20                 Allow 'tcp <type> <block-number>' commands
27                 Implement new 'max_retry_timer' (tcp mrtt [milliseconds])
57                 Enhance 'tcp irtt' command to show cashed stuff
58                 Make syntax of error- and usage-messages more consistent
59                 Make syntax of error- and usage-messages more consistent
68                 Don't reset a 'Closed' session because this will crash NET/Mac
70                 Implement 'tcp active' command (suppressed 'tcp status')
70                 Implement 'tcp extended' command (extended 'tcp active')
73                 Implement fixes for more 'Real-Time processing'
07R                Show inactiveTimer in 't s #' command-output
 +  tcpdump.c      Support 'trace <interface> <bits> [filename]'
57  tcpin.c        Implement cashing of rtt settings (by AF2J)
73                 Implement fixes for more 'Real-Time processing'
78                 Make sure pullup() gets called with the right parametertype
50  tcpip..rsrc   Taken from V2.2
 +                 HELP-info added/changed over various releases of NET/Mac
80                 Added 'rotating cursor'
27  tcpout.c       Implement new 'max_retry_timer' (tcp mrtt [milliseconds])
44                 Make sure counters remain positive
73                 Implement fixes for more 'Real-Time processing'
82                 Try to keep the retry-timers AT LEAST 5 seconds
27  tcpsubr.c      Implement new 'max_retry_timer' (tcp mrtt [milliseconds])
57                 Implement cashing of rtt settings (by AF2J)
73                 Implement fixes for more 'Real-Time processing'
03R                Mods for inactiveTimer
32  tcptimer.c     Make sure counters remain positive
01R                Mods for smtpndays
02R                Mods for smtpndays
23R                Enhance checking for obsolete open sessions
78  tcpuser.c      Make sure pullup() gets called with the right parametertype
57  tcp_rtt.c      New sourcefile for cashing of rtt settings (by AF2J)
 +  telnet.c       Mods for UPLOAD command
25                 Force incoming data to the right window
29                 Close <session> doesn't crash a Mac with minimum system
42                 Do flowcontrol for incoming lines and those typed
51                 Force state-changes to the right window
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
55                 Log outgoing telnet-session
60                 Save some space by moving some strings to 1 variable
67                 Cursors should appear only if typing in a window is allowed
78                 Make sure pullup() gets called with the right parametertype
14R                Don't send incoming null-characters to the TELNET-session-window
21R                Log reason for closing a session in case of networkproblems
 +  timer.c        Mods for reboot-problem
49                 If smtp timer > 3276 (*10 mSec) no smtp kick occurred
73                 Implement fixes for more 'Real-Time processing'
74                 Add some conditional debugging code
09R                Mods for the statistics window
14R                Check the result of the time() function
22R                Don't allow msPTick > 1000 or 'division by zero' may occur
73  timer.h        Implement fixes for more 'Real-Time processing'
 +  tnserv.c       Display callsign not ip-number on incoming telnet-session
48                 Incoming sessions draw more attention than incoming mail
60                 Save some space by moving some strings to 1 variable
67                 Cursors should appear only if typing in a window is allowed
68                 Implement split-windows for TELNET, AX.25 and NET/ROM
04R                Enable/disable Custom menu depending on frontwindow
15R                Return resultcode 0 if all was OK
19R                Mods for correctly displaying the systemprompt
21R                For incoming TELNET-sessions send out CTEXT1 and CTEXT2 
22R                Limit the number of TELNET sockets and keep track of those
 +  trace.c        Support 'trace <interface> <bits> [filename]'
46                 Show date and time while tracing
52                 Support 'traceonly [all|callsign]'
53                 Mod for trace <interface> 111 (211 was OK)
78                 Make sure pullup() gets called with the right parametertype
14R                Check the result of the time() function
14R trace.h        Implemented mods for Serial Line Framing Protocol
78  udp.c          Make sure pullup() gets called with the right parametertype
82                 Fix sporadic odd address errors
14R                Make sure udp.c uses iface.h
 +  udpdump.c      Support 'trace <interface> <bits> [filename]'
 
76  Lots of files  Installation of conditional sourcecode-compilation
                   and removal of non-Mac sources
12R                Mods for MFS-only Macintoshes
14R                Mods for MFS-only Macintoshes
15R                Mods for MFS-only Macintoshes
15R                Return error-code 0 if all was OK
 
Priority
   1                   Get rid of 'outgoing checksum errors'
   1                   Support COPY menu option
   2    NET/ROM        Support NET/ROM connections over AppleTalk links
   2    AX.25          Support AX.25 connections over AppleTalk links
   2                   Domain nameserver
   2                   POP-server
   2                   Control-X should terminate a C)hat; back to the mbox
   3    FTP            Support type ahead of commands
   4    UPLOAD         Fix NET/ROM uploads
   5    SMTP           Allow mailforwarding to RLI/MBS-boxes
 
 */
 
 /*
 
 About some new things and new (or changed) commands and how to use those:
 
 
 UPLOAD and RECORD: Switch from the AX.25- or TELNET window to the console
 window and type 'UPLOAD <filename>' or 'RECORD <filename>'. So make sure
 you go from the window for which the UPLOAD/RECORD is intended DIRECTLY
 to the console window, otherwise you'll get an errormessage.
 In NET/Mac(58) and higher versions you may also use the format:
 upload <filename> [<session>]  and  record <filename> [<session>|off]
 
 
 ROUTE EXPANDED: Displays the routing table like the ROUTE command does,
 but IP-numbers will be translated into hostnames. This may take some time
 because the hostnames have to be looked up in the HOSTS.NET file.
 I suggest you just use this form when you have a RAM-cache enabled in
 your controlpanel. Oh... you cannot type a shortcut for EXPANDED, so
 'ro e' will not work. This is just to prevent one from accidently typing
 this command.
 
 
 TCP MRTT [<milliseconds>]: You may use this new command to set a Maximum
 ReTry Timer. The default time is 3600 seconds (3600000), which means
 that when a link has gone down, or has gone bad, there will be a retry
 at least once every hour. This timer was created so that the retry-
 timer doesn't go up too high. Don't set this timer to a (too) low value,
 because you may introduce a lot of retries for a down link, which means
 a lot of unnecessary traffic on the frequency. This MRTT is valid for
 ALL open connections. I suggest you DON'T set it to a value lower than
 900000 (900 seconds) or so.
 
 
 #$debug on: You may choose to list the commands in the autoexec.net-file
 when they are being executed. This is very handy to trace errors in the
 startup-file. NET/Mac will start showing the commands when it discovers
 a line containing   #$debug on   in the autoexec.net file.
 
 
 FLOW [ON|OFF]: Enable or disable 'flow-control' for TELNET-, NET/ROM-
 and AX.25-sessions. With flowcontrol ON an incoming line will not be
 written to the screen as long as you are in the middle of typing a line
 for the remote station. Incoming data will be displayed as soon as you
 hit the <RETURN> key. So far flowcontrol is not perfect, but I think it
 is a lot better than it used to be. Anyway, it works fine, as long as
 you don't type HALF a line in one session, and then switch to another and
 do some typing there, and then switch back and so on. If you simply type
 a COMPLETE line at a time it's OK.
 
 
 ALERTS [<number>]: Sets the number of bell-strikes for incoming sessions.
 <number> may be a number from 0 to 5. When <number> is 0, no bell will 
 sound for incoming sessions or incoming mail. When <number> is bigger than
 0 incoming mail will sound 1 bell (like it used to be), but incoming
 live sessions like TELNET-, AX.25- and NET/ROM-sessions will sound as
 many bells as defined in the ALERTS command. This command was created so
 incoming sessions may draw more attention than incoming mail- or finger-
 sessions.
 
 
 ROUTE ADD DEFAULT <interface>: I suggest you DON'T USE THIS FORM, but use
 ROUTE ADD [44.0.0.0]/8 <interface>  instead.
 
 
 At startup the program prints out a line containing the Macintoshtype and
 two type-numbers. If it says 'Macintosh Computer', then please inform me
 about the type of Macintosh you are running NET/Mac on (like Plus, SE etc.)
 and the typenumbers it printed, so that I can add the Macintoshtype you
 are using. So far it should recognize most of the Macintoshes.
 Note that a Mac-XL running a Mac Plus emulator, or a 512Ke with a SCSI-
 interface and/or 1 MByte of memory (or more), are considered to be a Plus!
 
 
 TRACEONLY [ALL|CALLSIGN] allows you to only expand packets to or from a
 given station (doesn't work for AppleTalk-tracing). This 'option' was
 installed because sometimes, on a very busy channel, it used to be close
 to impossible to return from the trace-window to the console-window (in
 order to switch tracing off).

 
 OUTGOING-MAIL-OPTIMIZER: NET/Mac(54) and higher versions contain an
 'outgoing-mail-optimizer'. It performs the following task:
 Suppose someone sends me (pa2aga) ONE mail for a number of hams, like:
 To: pe0mar@pa2aga pa0aax@pa2aga pa0gln@pa2aga on1xk@pa2aga
 Now, what used to happen is the following:
 Using the alias-file of pa2aga, mail would be re-queued to:
 pe0mar@pi8hvh pa0aax@pi8hvh pa0gln@pi8mac on1xk@pi8hvh
 4 files in total, of which 3 would be sent (one after another) to pi8hvh.
 I always thought this was a waste of bandwidth, so...
 My optimizer does the trick now, NET/Mac takes care of it all!
 It will send one file to pi8mac and ONE file to pi8hvh!
 
 
 RIP TRACE [ON|OFF]: Allows you to trace RIP-activity in a RIP-dedicated
 Window. These mods came from Joe AF2J (thanks Joe!). Note that when A LOT
 of routes get added through the RIP-mechanism, the RIP-trace-window may
 slow down NET/Mac for a while, because (like ROUTE EXPANDED) all IP-numbers
 will get translated to hostnames before the messages in the RIP-trace window
 are displayed. This may require some (a lot) of disk-accesses when the file
 'hosts.net' is not in a RAM-cache. I suggest you turn on the RIP TRACE when
 indeed you want to trace the RIP-stuff, otherwise turn RIP TRACE OFF.
 
 
 We have experienced some outgoing CHECKSUM ERRORs on both AppleTalk and
 TNC links. This problem causes AppleTalk links to become very  S L O W.
 To minimize this problem I have set both TCP MSS and TCP WINDOW to 216 so
 that there will never be more than 1 frame at a time going out over the
 AppleTalk link. This seems to have reduced it by 95%. Unfortunately MSS
 and WINDOW are being used for all tcp-connections, so setting both of them
 to the same value also limits the possibilities on the TNC-link, but as
 far as I've noticed here that doesn't really hurt. PE1CHL told me that the
 CHECKSUM ERROR problem also exists in his NET.PE1CHL, and that he is not
 going to solve it. He believes that it has been solved in NOS.
 
 
 For SLIP-lines you may now issue modemcommands like ATDT in a 'param'
 command. The format of the command is: param <interface> <modemcommand>
 Examples:  param sl0 ATDT031174942153 
            param sl0 +++
 Note: Only 1 string is sent to the modem.
       A <space> or <return> terminates the string.
 
 
 For KISS-lines you may now issue TNC-commands like KISS ON in a 'param'
 command. The format of the command is: param <interface> <TNC-command>
 Example:  param ax0 KISS ON
 Note: A <return> terminates the string.
 
 
 A new feature in NET/Mac(65) and higher is the 'anonymous anonymous' user.
 You can allow any user to log in by defining username * and password * in
 the ftpusers-file. When NET/Mac goes through the list of validated users,
 and it encounters a username *, then the search is terminated and the user
 is granted access to the system. You should put this line at the very end
 of ftpusers! You may also choose to remove any 'guest' or 'anonymous'
 user from the ftpusers-file, since * could cover all of those.
 
 
 Also new in version 65 is the 'prompt' command, which enables you to
 change the default 'net>' prompt.
 
 
 Version 67 and higher allow the user to define the location and size
 of the Trace-, RIP Trace-, LOG-, SMTP Trace- and CONSOLE-windows. If you
 haven't changed the commands that generate these windows, the windows will
 simply be like they used to be. If you want to change the size or location
 of a given window, simply add 4 numbers to the command, that creates it.
 (e.g.: log :spool:logs:log x y r c)
 The 4 numbers are: x and y: the coordinates of the upper left corner
                             default is 0 0
                    r      : number of rows (lines) in the window
                             default is 24 (on a 9" screen)
                    c      : number of columns (characters) per line
                             default is 80 (on a 9" screen)
                             
 Since the TRACE-command has an optional filename as the last parameter,
 it is required to use all 4 parameters (x y r c) for the windowsize or
 NON of those. The optional filename remains the LAST parameter.
 
 To change the location and size of the console-window a new command
 'console [x y r c]' was introduced.
 
 I myself use on a 9" screen:
 rip trace on 0 0 24 72
 smtp trace 2 0 19 17 80
 log :spool:logs:log overwrite 0 0 24 71
 console 0 0 13 80

 Example for 13" screen:
 rip trace on 0 0 24 80
 log :spool:logs:log overwrite 0 310 3 80
 smtp trace 2 0 374 3 80
 console 0 0 24 80
 
 Starting up NET/Mac with   #$debug on   may be pretty slow, especially
 when you have a large screen (let's say > 12"). If you want to speed up
 processing of the autoexec.net file you can first reduce the size of the
 console-window.
 On PA0GLN's Mac LC with 13" color-screen the startup took 24 seconds.
 He then installed the following line as the first line of his autoexec.net:
 console 0 0 10 80

 At the end of his autoexec.net he selected the screen as suggested above.
 Startup then took only 15 seconds.
 

 FLOW [ON|OFF] now also controls the kind of screen you will get when an
 AX.25-, NET/ROM- or TELNET-session is started. With FLOW OFF you will now
 get a split-screen, with an incoming and an outgoing window. When FLOW
 is ON, you will get one window in which both the incoming and outgoing
 data will be displayed.
 
 
 KPC-4 TNC: When a kpc-4 is attached, an "a" or "b" is added to <label>
 and is used in place of <interface> in all autoexec.net (and live) commands.
 So, when you do  'attach kpc4 1 a ax25 kp0 2048 576 4800'  your <interface>'s
 will be kp0a and kp0b.


 RTNTOSES [ON|OFF] allows you to enable/disable a mode in which typing
 a single <RETURN> in the console-window will/won't bring you back to
 the active session. Default is ON.
 
 
 REALTIME [ON|OFF] was implemented because I discovered, that timers
 appeared to be only relative values. When the Mac is busy running more
 than just NET/Mac, sometimes my timers (like SMTP TIMER, retry-timers
 etc.) look like actual values, but in many cases the real value was 1.5 to
 3 times higher than the ones shown by various commands. I always wondered
 why a ping with a delay of 900 seconds only got handled about twice an hour....
 When you switch on REALTIME, NET/Mac will try to investigate how busy the
 Mac is, and how little time NET/Mac gets from the system. By doing so and
 adjusting the timervalues these become more realistic. NET/Mac will average
 the values it found over some time. When you type REALTIME, it will show
 you the value it has calculated. The program usually uses the value 100,
 so if REALTIME shows 200 mSec per tick, this means, that all timers and
 counters are twice as long as you would expect. Also look at SMTP TIMER
 some time after switching on REALTIME, and you will see a more accurate
 value of the timer there.
 When you quit NET/Mac by using the 'exit' command, NET/Mac will put the
 average tick-value of the last NET/Mac-run at the beginning of your
 autoexec.net, so that it will automatically start up using this value when
 you activate NET/Mac the next time.
 
 
 CMDTOCLIPB [ON|OFF] appears to be handy when you want to have a possibility
 to redo the last command. This new command allows you to copy each and every
 command to the clipboard, so that you can 'retype' the command by simply
 pressing command-G (Do Again). It's a lot more comfortable to type (a lot of)
 command-G's than to type like 't s 5f873c' a number of times, just to monitor
 a given session. Command-V acts just like command-G, but the command will not
 really be executed, so that you can edit the command if you like.
 
 
 RIP really works in version 80 (and higher)!
 
 
 ADDMENU <string> allows you to enter commands from the menubar. Look at the
 HELP info for ADDMENU for more info.
 
 
 SOURCE <filename> allows you to split up the autoexec.net file into a number
 of smaller files, each performing a specific task, like 1 file for 'route add'
 commands, 1 file for 'arp add' commands etc... Also you may choose to group
 together a number of NET/Mac commands, that can be activated later from the
 'Custom' menu. See also the NET/Mac HELP-windows for 'addmenu' and 'source'.
 
 
 SMTP NDAYS <number> will make sure, that SMTP-files that have been inside your
 Macintosh (and could not be delivered) for more than <number> days, will get
 returned to the sender. The default value for <number> is 365 (days), but I
 think you should set it to some value of between 10 and 30. Mail-files are
 being checked against this <number> when they are queued for transmission.
 When NET/Mac stays on for very long without being restarted, this could mean,
 that there may be a session, waiting in SYN SENT mode for the destination to
 show up, for as long as NET/Mac is running. This would mean, that the outgoing
 mail to that (unreachable?) destination will only get queued when SMTP kicks
 for the first time, and never after. Therefore I implemented a mod, which makes
 sure that outgoing SMTP-sessions that reach retry-timer 128 (see 'tcp status')
 will get requeued again.
 Also outgoing SMTP-sessions that wait for a command from the destinationhost
 and seem to be 'forgotten' by that host will be reset after about 2 hours.
 
 
 TITLE <new consolewindow title> allows you to change the default title of the
 console-window (which now defaults to 'hostname') to any title you like.
 
 
 Sometimes it seems hard to disconnect a simple AX.25 connection by just typing
 a disconnect command... Instead of typing disconnect commands over and over,
 you should try the following: type: ax25 status
                      and then type: ax25 reset <'&AXB'-address>
 
 You should ONLY use these commands, when the state of the connection is (and
 remains) 'Conn pending', otherwise the remote-station will never know, that
 you have dropped the connection. 
 
 
 SLEEP <seconds> was added to allow users to put NET/Mac to sleep for some time.
 Sometimes this seems to be necessary after sending a command (like RESET) to a
 TNC. During the sleep period, which may last between 1 and 10 seconds, NET/Mac
 will not service any ports nor will it look at the keyboard.
 
 
 NETMACICONS [ON|OFF] allows you to control the type of Icon that the NET/Mac
 configurationfiles will have. When switched to ON, files like 'ftpusers',
 'alias', 'hosts.net' and 'autoexec.net' will eventually get a NET/Mac-like Icon.
 Some users did not like this because they would like to see TeachText or some
 other file-editor launched (instead of NET/Mac) whenever they double-click on
 the very file. When you decide to change the creator of the file to the NET/Mac
 application, the filetype will still remain TEXT, so that any editor will be
 able to edit the file. I myself changed the Icons to NET/Mac-like Icons, because
 I feel these files are really NET/Mac configuration files, and therefore should
 look like NET/Mac-documents. The default for NETMACICONS is ON.
 

 System 7.1 has a bug in AddResMenu() that messes up the HELP-window. NET/Mac
 now has it's own MyAddResMenu() to fix that. NET/Mac will check if it is running
 under 7.1 and if so it uses it's own routines, otherwise the system's AddResMenu
 will be used.
 
 
 Under the 'Settings' menu a new item '...View Statistics' was installed.
 This allows you to display a window, in which the realtime statistics are shown.
 For some reason I don't understand yet, background tasks will slow down a lot
 when this window is up, and therefore it 'self-destructs' in 15 seconds. I am
 still looking for the cause of this and will try to solve the problem as soon as
 possible.
 
 
 APPLESHARE [<HOSTNAME> <PATH_TO_MQUEUE_FOLDER>] was implemented in version 2.3.10.
 I wrote this command because I got sick of having to deal with badly performing
 AppleTalk TCP/IP links. The bad links are caused by some 'DUP MBUF' problem,
 which happens to occur much more on AppleTalk than on TNC-links. I think the
 problem rises when an ACK for a frame was received before the frame itself has
 been deleted from the outbound-frame-queue. Of course the chances, that this will
 happen on AppleTalk are relatively large because of it's high speed. On my network
 it happens most of the time when one of my Mac 512Ke's transfers SMTP-files to
 the IIx or SE/30. The IIx and SE/30 seem to ACK so quick, that the 512 doesn't
 have enough time to remove the transmitted frame from the queue. The new command
 allows the 512 to directly put the file to be transmitted into the MQUEUE folder
 of the IIx using AppleShare instead of the TCP/IP link. Sending out a 585K file
 took 7 minutes over TCP/IP, while the transmission lasted only 2.5 minutes over
 AppleShare. Bad links sometimes perform so bad, that I cannot get more than about
 5K sent in ONE HOUR! For the time being, you can define only 1 AppleShare host.
 In my case this did not appear to be a problem, because usually one Mac only
 forwards mail to one of the others. This happens to be the case since in Holland
 we are used to do hop-to-hop forwarding, and when mail comes in on one of the Macs
 it will be forwarded to the 'next in line' and to the next etc. So only the 'next
 in line' Mac has to be defined as AppleShare host. If for some reason the Apple-
 Share volume appears to be not-online, then NET/Mac will use TCP/IP-forwarding
 automatically.
 
   |                                      Suppose mail comes in at pa2aga for
   |                                      pa3ecp@pa2aga. The aliasfile of pa2aga
 A |                                      will reroute that to pa3ecp@pi8mac.
 p |--- pa2aga on 433.025 MHz. -- TNC     pa2aga has 1 AppleShare node: pi8mac,
 p |                                      so the mailfile will (if possible) be
 l | alias: pa3ecp  pa3ecp@pi8mac         forwarded over an AppleShare link.
 e |
 T |                                      pi8mac discovers the mail in it's own
 a |--- pi8mac on 430.675 MHz. -- TNC     mqueue-folder, while it is still
 l |                                      addressed to: pa3ecp@pi8mac, and will
 k | alias: pa3ecp  pa3ecp@pa2aga-2       send it over the loopback-link to
   |                                      itself. Then it will get aliassed to
 c |                                      pa3ecp@pa2aga-2, while pa2aga-2 is it's
 a |--- pa2aga-2 on 1259.675 MHz. -- TNC  known AppleShare node. Therefore, again
 b |                                      it will be sent over via AppleShare.
 l | alias: pa3ecp  pa3ecp@pa3ecp
 e |                                      Finally pa2aga-2 encounters mail for
   |                                      pa3ecp@pa2aga-2, and will send it to
                                          itself. The mail will then be rerouted
                                          to pa3ecp@pa3ecp and will finally be
                                          delivered over the TNC-link. pa2aga-2
                                          knows 1 AppleShare node: pa2aga
                                          
 example of the APPLESHARE command as it is in the autoexec.net of pa2aga:
 
 appleshare pi8mac "HD of PI8MAC:TCP/IP:spool:mqueue"
 
 Note: AppleShare mail-delivery will take place ONLY if the file gets QUEUED by
 NET/Mac (like in hop-to-hop forwarding). If you just typed a mail yourself, then
 IM/Mac will queue it. Therefore the first hop will go over a TCP/IP link while all
 next (AppleTalk-)hops may be using this AppleShare feature. I may decide to enhance
 this, but will not do so until the system has proven to REALLY be an enhancement.
 So far my AppleTalk TCP/IP links have been running well with this mod, and I'll
 keep my fingers crossed!
 We've tested this feature on standard AppleShare-volumes as well as TOPS-volumes.
 
 
 NET/Mac 2.3.14 contains new AppleTalk drivers. So far these seem to be much more
 reliable than the old drivers.
 
 I just want you to know that:
 1) You cannot mix NET/Mac 2.3.14 and pre-2.3.14 versions on 1 AppleTalk trunk,
    because they will not be able to communicate with eachother
 2) When one Mac on the AppleTalk link tries to send to another, while the other
    one isn't running NET/Mac yet, the first one seems to freeze for maybe half
	a minute or so, but don't panic... it will continue to run without problems
 3) The new NET/Mac may be used to connect to an ethernet-LAN over a Shiva
    FastPath or Cayman GatorBox. If no such gateway is discovered on the Apple-
	Talk LAN, NET/Mac will report 'No AppleTalk Gateway was found' when processing
	the 'attach' command for the AppleTalk port

 NET/Mac 2.3.15 contains upgraded new AppleTalk drivers. Again you cannot mix 2.3.15
 with earlier versions. Furthermore the last number in the attach-statement for the
 AppleTalk interface cannot be larger than 586, so 600 is invalid for NET/Mac 2.3.15.

 Dewayne WA8DZP, who sent me these fixes, wrote about hem:
 'When you do a trace for an AT interface now, the AT addresses are displayed in the'
 'standard net:node:socket convention for both source and destination.  The maximum '
 'packet size in the "attach at0" command should now be 586. This code will find any'
 'host running NET/Mac who is in the same AT zone. This should be a BIG improvement '
 'over the old LAP code that could only work over one network.	                    '
 
 NET/Mac also supports point-to-point SLFP, as used by the Merit Network and MIT.
 Check the HELP-info for the 'attach' command to see how to select SLFP.
 
 
 When you have just started up an FTP-session and you have typed: USER <username>
 you can now type your password without showing the password on the screen.
 To do this DON'T type: PASS <password>, but simply type: PASS and the system will
 ask you to type a password. The password will not be visible on the screen. If 
 you decide to use the old form (PASS <password>) the password WILL be visible!


 SESSCREEN [<screenwidth>] [<number_of_lines>] allows you to define the width and
 length of windows that will be opened for ftp-, telnet-, ax.25-, net/rom- and
 finger-sessions. The maximum size depends on the size of the screen. I figured out,
 that 90 by 25 is nice on my PowerBook 100, while the screen can be 101 characters
 wide by 29 lines long.
 
 
 The drivers for accessing the callsign-database have been changed so that NET/Mac
 will use the format of (and read) the new HamCall CD-ROM. Old callbook databases,
 that could be used by pre 2.3.15 versions of NET/Mac cannot be used any longer.
 
 HamCall CD-ROM:
 500,000 hams plus 1,000s of public domain amateur radio programs and data.
 NOW with international callsigns!!
 CD-ROM  $50
 Shipping $5

 Buckmaster Publishing
 Route 4, Box 1630
 Mineral, VA 23117
 (703)894-5777
 (800)282-5628
 
 After buying the october 1992 Buckmaster CD I discovered, that the databases are
 in an invisible folder. You can attach the U.S.A.-database using a command like:
 
 callbk HCALL_10_92:HAM0:HAMCALL.129;1 :spool:logs:callbook_log
               ^       ^               ^^^^^^^^^^^^^^^^^^^^^^^^
             these are zero's              just an example

 The international callbook file is encoded. To use it from NET/Mac you must use:
 
 callbk HCALL_10_92:HAM0:HAMCALL.ALL;1 :spool:logs:callbook_log encoded
 
 
 CALLBOOKSERVER <HOSTNAME> defines the callbook-server in your area. It is set to your
 own hostname by default. The 'inquire' command will retrieve the callbook-database
 at the station, which is defined by the 'callbookserver' command.


 INQUIRE <CALLSIGN> allows you to retrieve the callbook-database of a predefined
 callbook-server. The output is exactly the same as delivered to an ax.25- or
 NET/ROM-user, who sends an I)nquire <callsign> command to the mbox, or a TCP/IP-
 user who sends a 'finger %<user>@<callbookserver>'.
 
 
 CTEXT1 [<MESSAGE LINE 1>] and CTEXT2 [<MESSAGE LINE 2>] allow you to send out a
 2-line welcome message to the station that opens a TELNET-session to this host.
 If a message is idle, no data will be sent out. Setting or clearing out a message
 can be done as follows:   ctext1 "Welcome to TELNET at PA2AGA"
                           ctext2 "It's past midnight.. everybody is asleep here"
                     or:   ctext2 ""
                     
                     
 PERFORM [CLEAR]|[<COMMAND> <HH:MM>|+<DELAY> [ONCE|PERMANENT]] allows you to define
 commands, that will be executed at a given time. See HELP for examples.
 
 
 FTEXT1 [<MESSAGE LINE 1>] and FTEXT2 [<MESSAGE LINE 2>] do the same as the CTEXT
 commands, except that these 2 commands will define welcome messages that will be
 displayed when a new FTP-session gets opened.
 
 
 DONTALIAS <USER> [<USER> ...] enables recording of (so far) unknown aliases in a
 DynamicAliases file, while these aliases will then be used to reroute mail.
 It works like this:
 
 Suppose K1FRM knows he can send mail to K1TO via K1VIA, while the mail-path to
 K1FRM is so far unknown at both K1TO as well as K1VIA.
 K1FRM would then send his mail to: k1to%k1to@k1via
 (if K1TO is in the aliasfile of K1VIA he could also send it to: k1to@k1via)

 Now NET/Mac at K1VIA sees this mail coming in and if K1FRM is not defined in the
 'dontalias' command (and why should it be?), it will record K1FRM in it's
 DynamicAliases file. The same thing happens at K1TO.
 This means that starting now anybody can send mail to K1FRM by simply mailing it
 to: K1FRM@K1VIA or to: K1FRM@K1TO
 
 It is necessary to define your own <USER> in the dontalias command, just to make
 sure that mail sent out by yourself, but rerouted by someone else and going
 through your own NET/Mac again will not be looked at. Otherwise an alias for your
 own <USER> would get written to the DynamicAliases file, meaning that starting
 now mail to yourself would get rerouted to yourself, and rerouted again, and
 again and again.........
 
 NET/Mac will not record aliases for those <USERS>s, that are already defined in
 the real 'alias' file.
 
 
 SMTP VM was implemented in version 2.3.26. Scott Petrack <petrack@vnet.IBM.COM>
 reported a problem when NET/Mac was mailing to an IBM VM mainframe. The mainframe
 could not handle the way NET/Mac was doing it's SMTP session. When you need to
 SMTP to such a machine, make sure you use the 'smtp vm' command before you start
 sending out the first mail. You cannot UNDO this command, but it should work fine
 for all other implementations of SMTP, except that they may perform just a little
 slower.
 
 
 If for some reason you are using any version of SoftKISS older than version 1.8
 I suggest you add the command SOFTKISS to your autoexec.net file. This command
 enables some fixes in NET/Mac to take care of a few bugs in SoftKISS, that were
 solved in version 1.8.
 
 
 NET/Mac 2.3.28 supports the Hurdler HDS and HQS 4 port serialcard as well as the
 QuadraLink and QuadraLink DMA cards. This means that starting now you can connect
 up to 6 TNC's to 1 Macintosh (and probably even more if you use more than just
 one QuadraLink card). Check the modified online-HELP info for both the 'attach'-
 and 'quadralink' commands.
 
*/
